/* 

   Geeks Artificial Neural Network (G.A.N.N) - Remove Data From GKDB
   
   Copyright GNU/GPL 2005-2006 George Delaportas (qtgeo)
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

*/



//Geeks Remove Data (Function)
void GRemData(int GRegSerNum,long GOffset)

{

    //Variables
    int i,j,k,n;
    int Tmp;
    int iTmp[MAX_REG+1];
    float fTmp[MAX_REG+1];
    FILE *FileToUpdate;
    
    //Reset
    i=0;
    j=0;
    k=0;
    n=0;
    Tmp=-1;
    
    //Initialize GKDB
    FileToUpdate=fopen("GKDB","r");
    
    //Error Check
    if (FileToUpdate==NULL)
    
    {
    
        printf("Error:GKDB Was Not Found!\n");
        
        exit(1);
    
    }
    
    //Close GKDB
    fclose(FileToUpdate);
    
    //Initialize GHT
    FileToUpdate=fopen("GHT","r");
    
    while ((n=feof(FileToUpdate))==FALSE)
    
    {
    
        //Read GHT
        fscanf(FileToUpdate,"%i\n",&iTmp[i]);
        
        if (GRegSerNum==iTmp[i] AND Tmp==-1)
            Tmp=i;
        
        i++;
    
    }
    
    //Close GHT
    fclose(FileToUpdate);
    
    //Remove Specified Registration
    for (j=Tmp;j<i;j++)
    
    {
    
        if (GRegSerNum==iTmp[j])
        
        {
        
            iTmp[j]=0;
            iTmp[j+1]=0;
        
        }
    
    }
    
    //Produce Updated GHT
    for (j=Tmp;j<i;j++)
    
    {
    
        if (iTmp[j]==0)
        
        {
        
            iTmp[j]=iTmp[j+1];
        
        }
    
    }
    
    //Initialize GHT
    FileToUpdate=fopen("GHT","w");
    
    //Save New GHT
    for (j=0;j<i;j++)
    
    {
    
        if (iTmp[j]!=0)
        
        {
        
            fprintf(FileToUpdate,"%i\n",iTmp[j]);
            printf("iTmp[%i]:%i\n",j,iTmp[j]);
        
        }
    
    }
    
    //Close GHT
    fclose(FileToUpdate);
    
    //Initialize GHT
    FileToUpdate=fopen("GHT","r");
    
    //Read GHT
    fscanf(FileToUpdate,"%i\n");
    
    //GKDB Removal Check
    if ((n=feof(FileToUpdate))!=FALSE)
    
    {
    
        printf("Notice:All The Registrations Were Removed\n");
        printf("Removing GKDB...\n");
        
        system("rm GKDB GHT GRegs GSims");
        
        printf("Done!\n");
        
        exit(0);
    
    }
    
    //Close GHT
    fclose(FileToUpdate);
    
/*    
    //Reset
    i=0;
    j=0;
    n=0;
    
    //Initialize GSims
    FileToUpdate=fopen("GSims","r");
    
    while ((n=feof(FileToUpdate))==FALSE)
    
    {
    
        //Read GSims
        fscanf(FileToUpdate,"%i\n",&iTMP[i]);
        
        if (GRegSerNum==iTMP[i])
            Tmp=i;
        
        i++;
    
    }
    
    //Close GSims
    fclose(FileToUpdate);
    
    //Remove Specified Registration
    for (n=0;n<2;n++)
        for (j=Tmp;j<i;j++)
            iTMP[j]=iTMP[j+1];
    
    //Initialize GSims
    FileToUpdate=fopen("GSims","w");
    
    //Save New GSims
    for (j=0;j<i;j++)
        fprintf(FileToUpdate,"%i\n",iTMP[j]);
    
    //Close GSims
    fclose(FileToUpdate);
    
    //Reset
    i=0;
    j=0;
    n=0;
    
    //Initialize GRegs
    FileToUpdate=fopen("GRegs","r");
    
    while ((n=feof(FileToUpdate))==FALSE)
    
    {
    
        //Read GRegs
        fscanf(FileToUpdate,"%i\n",&iTMP[i]);
        
        if (GRegSerNum==iTMP[i])
            Tmp=i;
        
        i++;
    
    }
    
    //Close GRegs
    fclose(FileToUpdate);
    
    //Remove Specified Registration
    for (n=0;n<2;n++)
        for (j=Tmp;j<i;j++)
            iTMP[j]=iTMP[j+1];
    
    //Initialize GRegs
    FileToUpdate=fopen("GRegs","w");
    
    //Save New GRegs
    for (j=0;j<i;j++)
        fprintf(FileToUpdate,"%i\n",iTMP[j]);
    
    //Close GRegs
    fclose(FileToUpdate);
    
    //Reset
    i=0;
    j=0;
    n=0;
    
    //Initialize GKDB
    FileToUpdate=fopen("GKDB","r");
    
    //Set Pointer At Specified Registry
    fseek(FileToUpdate,GOffset,SEEK_SET);
    
    while ((n=feof(FileToUpdate))==FALSE)
    
    {
    
        //Read GKDB
        fscanf(FileToUpdate,"%f\n",&fTMP[i]);
        
        if (GRegSerNum==fTMP[i])
            Tmp=i;
        
        i++;
    
    }
    
    //Close GKDB
    fclose(FileToUpdate);
    
    //Remove Specified Registration
    for (n=0;n<2;n++)
        for (j=Tmp;j<i;j++)
            fTMP[j]=fTMP[j+1];
    
    //Initialize GKDB
    FileToUpdate=fopen("GKDB","w");
    
    //Save New GKDB
    for (j=0;j<i;j++)
        fprintf(FileToUpdate,"%f\n",fTMP[j]);
    
    //Close GKDB
    fclose(FileToUpdate);
*/
}

/* ------------------------------------------------------------------------ */
