/* 

   Geeks Artificial Neural Network (G.A.N.N) - Runtime Manager Console
   
   Copyright GNU/GPL 2005-2006 George Delaportas (qtgeo)
   
   This program is free software; you can redistribute it and/or modify
   it under the terms of the GNU General Public License as published by
   the Free Software Foundation; either version 2 of the License, or
   (at your option) any later version.
   
   This program is distributed in the hope that it will be useful,
   but WITHOUT ANY WARRANTY; without even the implied warranty of
   MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE. See the
   GNU General Public License for more details.
   
   You should have received a copy of the GNU General Public License
   along with this program; if not, write to the Free Software
   Foundation, Inc., 51 Franklin St, Fifth Floor, Boston, MA  02110-1301 USA

*/



//Geeks Runtime Manager Console (Function)
void GRMC(int RMCFunc)

{

    //Variables
    int i,j,k;
    int REGS[MAX_REG];
    int OFFSETS[MAX_REG];
    FILE *FileToCheck;
    
    //Reset
    i=0;
    j=0;
    k=0;
    
    //Initialize GKDB
    FileToCheck=fopen("GKDB","r");
    
    //Error Check
    if (FileToCheck==NULL)
    
    {
    
        printf("Error:GKDB Was Not Found!\n");
        
        exit(1);
    
    }
    
    //Close GKDB
    fclose(FileToCheck);
    
    //Initialize GRegs
    FileToCheck=fopen("GRegs","r");
    
    //Get GRegs
    while ((i=feof(FileToCheck))==FALSE)
    
    {
    
        fscanf(FileToCheck,"%i\n",&REGS[j]);
        
        j++;
    
    }
    
    //Close GRegs
    fclose(FileToCheck);
    
    //Show Registrations
    printf("-----------------------------------------\n\n");
    
    for (i=0;i<j;i++)
        printf("Registration:%i   Serial Number:%i\n\n",i+1,REGS[i]);
    
    printf("-----------------------------------------\n\n");
    
    //User Interaction
    printf("# Geeks Runtime Manager Console #\n");
    printf("Please Specify A Registration Serial Number\n");
    printf("Choice:");
    
    scanf("%i",&RegSerNum);
    
    for (i=0;i<j;i++)
    
    {
    
        if (RegSerNum==REGS[i])
        
        {
        
            k=1;
            
            break;
        
        }
    
    }
    
    if (k==0)
    
    {
    
        printf("Error:The Serial Number You Specified Does Not Exist!\n");
        
        exit(1);
    
    }
    
    printf("\n");
    
    //Reset j
    j=0;
    
    //Initialize GHT
    FileToCheck=fopen("GHT","r");
    
    //Get The Right Offset By Searching With RegSerNum
    while ((i=feof(FileToCheck))==FALSE)
    
    {
    
        fscanf(FileToCheck,"%i\n",&k);
        fscanf(FileToCheck,"%i\n",&OFFSETS[j]);
        
        if (k==RegSerNum)
            break;
        
        j++;
    
    }
    
    //Close GHT
    fclose(FileToCheck);
    
    //Fixate Offset
    if (RegSerNum==REGS[0])
        Offset=0;
    else
        Offset=OFFSETS[j-1];
    
    //Check Function
    if (RMCFunc==0)
    
    {
    
        printf("Please Specify Running Mode Threshold\n");
        printf("(Threshold Must Be A Positive Value Between 1-100%%)\n");
        printf("Choice:");
        
        scanf("%f",&RunTH);
        
        if (RunTH<1.0 OR RunTH>100.0)
        
        {
        
            printf("Error:Threshold Value Must Be Between 1-100%%!\n");
            
            exit(1);
        
        }
        
        printf("\n");
        
        printf("Please Specify How Many Values Do You Want To Input\n");
        printf("(Input Number May Be A Positive Integer Between 1-%i)\n",MAX_PIN);
        printf("Choice:");
        
        scanf("%i",&i);
        
        if (i<1 OR i>MAX_PIN)
        
        {
        
            printf("Error:Wrong Input Number Specified!\n");
            
            exit(1);
        
        }
        
        printf("\n");
        
        for (j=0;j<i;j++)
        
        {
        
            printf("Please Specify A Test Value\n");
            printf("(Test Value May Be Of Any Type)\n");
            printf("Choice:");
            
            scanf("%f",&UserVal[j]);
            
            printf("\n");
        
        }
        
        printf("\n");
        
        //Keep User Inputs
        UserInp=i;
    
    }
    
    else if (RMCFunc==1)
    
    {
    
        printf("Removing Registration...\n");
        
        GRemData(RegSerNum,Offset);
    
    }
    
    else
    
    {
    
        printf("Error:Wrong Function Specified!\n");
        
        exit(1);
    
    }

}

/* ------------------------------------------------------------------------ */
